{% extends "layout.html" %}
{% block title %}Charts {{ sensor_type.title() }}{% endblock %}
{% block section %}Chart {{ sensor_type.title() }} Sensor{% endblock %}
{% block head %}
{{ super() }}
  <!-- Bootstrap time Picker -->
  <link rel="stylesheet" href="/static/plugins/timepicker/bootstrap-timepicker.min.css">
  <link rel="stylesheet" href="/static/bower_components/bootstrap-daterangepicker/daterangepicker.css">
  <!-- bootstrap datepicker -->
  <link rel="stylesheet" href="/static/bower_components/bootstrap-datepicker/dist/css/bootstrap-datepicker.min.css">
{% endblock %}
{% block content %}
  <!-- Default box -->
  <div class="box box-default">
    <!-- /.box-header -->
    <div class="box-body">
      <div class="row">
        <form class="form-schedule" action="/sensors/statistics/{{ sensor_type }}" method="get">
        <div class="col-md-3">
          <div class="form-group">
            <label>Sensors:</label>
            <select name="sensor" class="form-control select2" style="width: 100%;" required>
              {% for sensor in sensors %}
                  <option value="{{ sensor.id }}">{{ sensor.name }}</option>
              {% endfor %}
            </select>
          </div>
        </div>
        <!-- /.col -->
        <div class="col-md-4">
            <div class="form-group">
              <label>Date Interval:</label>
              <input type="text" name="dates" class="form-control pull-left" value="{{ dates }}">
              <!-- /.input group -->
            </div>
            <!-- /.form group -->
        </div>
        <!-- /.col -->
        <input type="hidden" name="timezone" value="" id="timezone">
        <div class="col-md-2">
            <label></label>
            <div class="input-group">
            <span class="input-group-btn">
              <button class="btn btn-success form-control" type="submitt">Search</button>
            </span>
          </div>
          <!-- /.form group -->
        </div>
        </form>
      </div>
      <!-- /.row -->
      <div class="row">
        <div class="col-md-12">
          <p class="text-center">
            <strong>{{ dates }}</strong>
          </p>
          <div class="chart">
            <!-- Sales Chart Canvas -->
            {% if result %}
              <canvas id="chart" style="height: 450px;"></canvas>
            {% endif %}
          </div>
          <!-- /.chart-responsive -->
        </div>
        <!-- /.col -->
      </div>
    </div>
    <!-- /.box-body -->
  </div>
{% endblock %}
{% block jquery %}
{{ super() }}
<script src="/static/bower_components/moment/min/jstz.js"></script>
<script src="/static/bower_components/moment/min/moment.min.js"></script>
<script src="/static/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
<script src="/static/bower_components/bootstrap-datepicker/dist/js/bootstrap-datepicker.min.js"></script>
<script src="/static/plugins/timepicker/bootstrap-timepicker.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.6.0/Chart.js"></script>
<script type="text/javascript">
$(function() {
    $('input[name="dates"]').daterangepicker({
        timePicker: true,
        timePicker24Hour: true,
        timePickerIncrement: 1,
        locale: {
        format: 'YYYY-MM-DD HH:mm:ss'
        }
    });
});
</script>
<script language="javascript">
    function getTimezoneName() {
        timezone = jstz.determine();
        return timezone.name();
    }
    document.getElementById("timezone").value = getTimezoneName();
</script>
{% if result and sensor_type == 'mijia' %}
<script>
    // set default to straight lines - no curves
    // Chart.defaults.global.elements.line.tension = 0;
    // set default no fill beneath the line
    Chart.defaults.global.elements.line.fill = false;

    var barChartData = {
      labels: [{% for item in result %}
                  moment("{{ item.timestamp.strftime('%Y-%m-%dT%H:%M:%SZ') }}").format('YYYY-MM-DD HH:mm'),
              {% endfor %}],
      datasets: [{
        type: 'line',
        label: 'Temperature',
        yAxisID: "y-axis-0",
        borderColor: "rgba(217,83,79,0.75)",
        backgroundColor: "rgba(217,83,79,0.75)",
        data: [{% for item in result %}
                      "{{ item.temperature }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Humidity',
        yAxisID: "y-axis-0",
        borderColor: "rgba(92,184,92,0.75)",
        backgroundColor: "rgba(92,184,92,0.75)",
        data: [{% for item in result %}
                      "{{ item.humidity }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Battery',
        yAxisID: "y-axis-1",
        borderColor: "rgba(51,51,51,0.5)",
        backgroundColor: "rgba(51,51,51,0.5)",
        data: [{% for item in result %}
                      "{{ item.battery }}",
                    {% endfor %}]
      }]
    };

    var ctx = document.getElementById("chart");
    // allocate and initialize a chart
    var ch = new Chart(ctx, {
      type: 'line',
      data: barChartData,
      options: {
        title: {
          display: false,
          text: "Statistics Mijia Sensor"
        },
        tooltips: {
          mode: 'label'
        },
        responsive: true,
        scales: {
          xAxes: [{
            stacked: true,
            scaleLabel: {
                display: true,
                labelString: 'Timestamp'
            },
            gridLines : {
                display : true
            }
          }],
          yAxes: [{
            stacked: false,
            position: "left",
            id: "y-axis-0",
            scaleLabel: {
                display: true,
                labelString: 'Temperature / Humidity'
            },
            gridLines : {
                display : true
            }
          }, {
            stacked: false,
            position: "right",
            id: "y-axis-1",
            scaleLabel: {
                display: true,
                labelString: 'Battery'
            },
            gridLines : {
                display : true
            }
          }]
        }
      }
    });

</script>
{% elif result and sensor_type == 'flora' %}
<script>
    // set default to straight lines - no curves
    // Chart.defaults.global.elements.line.tension = 0;
    // set default no fill beneath the line
    Chart.defaults.global.elements.line.fill = false;

    var barChartData = {
      labels: [{% for item in result %}
                  moment("{{ item.timestamp.strftime('%Y-%m-%dT%H:%M:%SZ') }}").format('YYYY-MM-DD HH:mm'),
              {% endfor %}],
      datasets: [{
        type: 'line',
        label: 'Temperature',
        yAxisID: "y-axis-0",
        borderColor: "rgba(217,83,79,0.75)",
        backgroundColor: "rgba(217,83,79,0.75)",
        data: [{% for item in result %}
                      "{{ item.temperature }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Moisture',
        yAxisID: "y-axis-0",
        borderColor: "rgba(92,184,92,0.75)",
        backgroundColor: "rgba(92,184,92,0.75)",
        data: [{% for item in result %}
                      "{{ item.moisture }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Light',
        yAxisID: "y-axis-0",
        borderColor: "rgba(255, 204, 0, 0.54)",
        backgroundColor: "rgba(255, 204, 0, 0.54)",
        data: [{% for item in result %}
                      "{{ item.light }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Conductivity',
        yAxisID: "y-axis-1",
        borderColor: "rgba(0, 76, 255, 0.66)",
        backgroundColor: "rgba(0, 76, 255, 0.66)",
        data: [{% for item in result %}
                      "{{ item.conductivity }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Battery',
        yAxisID: "y-axis-1",
        borderColor: "rgba(51,51,51,0.5)",
        backgroundColor: "rgba(51,51,51,0.5)",
        data: [{% for item in result %}
                      "{{ item.battery }}",
                    {% endfor %}]
      }]
    };

    var ctx = document.getElementById("chart");
    // allocate and initialize a chart
    var ch = new Chart(ctx, {
      type: 'line',
      data: barChartData,
      options: {
        title: {
          display: false,
          text: "Statistics Flora Sensor"
        },
        tooltips: {
          mode: 'label'
        },
        responsive: true,
        scales: {
          xAxes: [{
            stacked: true,
            scaleLabel: {
                display: true,
                labelString: 'Timestamp'
            },
            gridLines : {
                display : true
            }
          }],
          yAxes: [{
            stacked: false,
            position: "left",
            id: "y-axis-0",
            scaleLabel: {
                display: true,
                labelString: 'Temperature / Moisture / Light'
            },
            gridLines : {
                display : true
            }
          }, {
            stacked: false,
            position: "right",
            id: "y-axis-1",
            scaleLabel: {
                display: true,
                labelString: 'Conductivity / Battery'
            },
            gridLines : {
                display : true
            }
          }]
        }
      }
    });

</script>
{% endif %}
{% endblock %}